=== 3rdparty/lua_yajl/CMakeLists.txt ===
PROJECT(lua_yajl LANGUAGES C)

FIND_PACKAGE(Lua51 REQUIRED)
FIND_PACKAGE(YAJL REQUIRED)

ADD_LIBRARY(lua_yajl STATIC lua_yajl.c)

TARGET_LINK_LIBRARIES(lua_yajl ${LUA_LIBRARIES} ${YAJL_LIBRARIES})

TARGET_INCLUDE_DIRECTORIES(lua_yajl PRIVATE
  ${LUA_INCLUDE_DIR}
  ${YAJL_INCLUDE_DIR}
)
