=== debian/changelog ===
mudlet (1:3.3.1-1) unstable; urgency=medium

  * New upstream release, Closes: #870208
  * Updated to standards version 4.0.0

 -- Craig Small <csmall@debian.org>  Sun, 06 Aug 2017 21:10:43 +1000
