## mudlet 3.5.0

=== debian/changelog ===
mudlet (1:3.5.0-1) unstable; urgency=medium

  * New upstream release
  * Fix edebee compile error Closes: #871027
  * Update to standards 4.1.1 - no change

 -- Craig Small <csmall@debian.org>  Fri, 20 Oct 2017 22:45:23 +1100
