=== debian/control ===
Source: mudlet
Section: games
Priority: extra
Maintainer: Craig Small <csmall@debian.org>
Build-Depends: debhelper (>= 9), pkg-config,
               libpcre3-dev, zlib1g-dev, libboost-dev, libyajl-dev,
               libhunspell-dev,
               qtbase5-dev, qt5-qmake, qttools5-dev, qtmultimedia5-dev,
               libqt5opengl5-dev,
               liblua5.1-dev, libzip-dev
Standards-Version: 4.1.1
Vcs-Git: git://anonscm.debian.org/collab-maint/mudlet.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mudlet.git
Homepage: http://www.mudlet.org/

Package: mudlet
Architecture: alpha amd64 arm64 hppa i386 ia64 m32r m68k mips mipsel powerpc ppc64 ppc64el s390 s390x sh3 sh3eb sparc sparc64 x32
Depends: ${shlibs:Depends}, ${misc:Depends},
         lua5.1-rex-pcre, lua5.1-sql-sqlite3,
         lua-filesystem, lua-zip
Suggests: hunspell-en-us
Description: Graphical MUD client with fast lua scripting support
 A completely redesigned MUD (Multi User Dungeon) client that is easy to
 use and customise.  Both power users and plain gamers alike will feel at
 home with Mudlet, without having to waste too much timer figuring out
 how to do something.
 . 
 Mudlet is designed to be very fast and efficient right from the start.
 Its scripting engine is designed to handle thousands of lines under
 one second. The scripting framework uses Lua - a small, fast and
 efficient scripting language.
